oracle.dbtools.plugin.api

## Enum ExtensionPoints

- java.lang.Object
- - java.lang.Enum<ExtensionPoints>
  - - oracle.dbtools.plugin.api.ExtensionPoints

- All Implemented Interfaces:
    Serializable, Comparable<ExtensionPoints>

      public enum ExtensionPoints
      extends Enum<ExtensionPoints>

  Enumerates the types of extensions that plugins can provide.
  Author:
    cdivilly

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `COMMAND_LINE` An extension that contributes a `CommandProvider` commandline sub-command.
    `CONFIGURATION_SETTING` An extension that contributes a `ConfigurationSetting`.
    `HTTP_FILTER` An extension that contributes a servlet `Filter`.
    `HTTP_SERVLET` An Extension that contributes a `HttpServlet`.
    `LIFECYCLE` An Extension that participates in the application startup and/or shutdown process.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Class<?>` | `type()` The type of the extension point
    `static ExtensionPoints` | `valueOf(String name)` Returns the enum constant of this type with the specified name.
    `static ExtensionPoints[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### CONFIGURATION_SETTING

          public static final ExtensionPoints CONFIGURATION_SETTING

      An extension that contributes a `ConfigurationSetting`.

      Plugins are not encouraged to contribute additional `ConfigurationSetting`s as each additional setting adds to the complexity of configuring and maintaining product deployments. When a setting is unavoidable a plugin must advertise the `ConfigurationSetting`s that it introduces.

    - #### COMMAND_LINE

          public static final ExtensionPoints COMMAND_LINE

      An extension that contributes a `CommandProvider` commandline sub-command.

    - #### HTTP_FILTER

          public static final ExtensionPoints HTTP_FILTER

      An extension that contributes a servlet `Filter`. The filter must be annotated with the `Priority` annotation and use one of the rings defined by `FilterOrder` to indicate at what stage in the filtering pipeline it should be invoked. The filter will be invoked for every request.

    - #### HTTP_SERVLET

          public static final ExtensionPoints HTTP_SERVLET

      An Extension that contributes a `HttpServlet`. The implementation must be annotated with the `Dispatches` annotation to advertise the route patterns that it handles.

    - #### LIFECYCLE

          public static final ExtensionPoints LIFECYCLE

      An Extension that participates in the application startup and/or shutdown process. If the order in which a provider is invoked is important, then the implementation type should be annotated with `Priority` to indicate where in the startup/shutdown cycle it should be invoked.

  - ### Method Detail

    - #### values

          public static ExtensionPoints[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (ExtensionPoints c : ExtensionPoints.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static ExtensionPoints valueOf(String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `IllegalArgumentException` - if this enum type has no constant with the specified name
        `NullPointerException` - if the argument is null

    - #### type

          public Class<?> type()

      The type of the extension point
      Returns:
        The extension point type

Copyright © 2010, 2022, Oracle and/or its affiliates.